; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: UNO.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x3E80 ; WORD
.equ        UBRR_VAL  =  0x19 ; BYTE
.equ        WAITKON  =  0x0010 ; WORD
.equ        WAITKON2  =  0x02D0 ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
STEUER_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
WRITE_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
SER_ZEICHEN:   ; Byte
.byte     1
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
    COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x02D0)
        LDI        R17, HIGH(0x02D0)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_065
        RJMP       M_IF_066
M_IF_065:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_066:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (INIT_SER_PORT)
INIT_SER_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRR0H)
        STS        UBRR0H, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, 0x19
 
; Zuweisung Ziel /  VAR (UBRR0L)
        STS        UBRR0L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER_PORT)
        RET
 
; PROCEDURE - Anfang (RX_PUFFER_ABFRAGEN)
RX_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_078
        CLR        R16
        RJMP       M_VERGL_079
M_VERGL_078:
        SER        R16
M_VERGL_079:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_075
        RJMP       M_IF_076
M_IF_075:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (SER_ZEICHEN)
        STS        SER_ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_077
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_076:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER_ZEICHEN)
        STS        SER_ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_077:
 
; PROCEDURE - Ende (RX_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN)
SENDE_ZEICHEN:
 
; WHILE DO ...
M_WHILE_080:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_083
        CLR        R16
        RJMP       M_VERGL_084
M_VERGL_083:
        SER        R16
M_VERGL_084:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_081
        RJMP       M_WHILE_082
M_WHILE_081:
 
; WHILE DO ...
        RJMP       M_WHILE_080
M_WHILE_082:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (SENDE_HEX_ZEICHEN)
SENDE_HEX_ZEICHEN:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_088
        CLR        R16
        RJMP       M_VERGL_089
M_VERGL_088:
        SER        R16
M_VERGL_089:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_085
        RJMP       M_IF_086
M_IF_085:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_087
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_086:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_087:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (HEXHIGH) retten
        MOV        R18, R2
 
; lokalen Parameter (HEXHIGH) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R18
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_093
        CLR        R16
        RJMP       M_VERGL_094
M_VERGL_093:
        SER        R16
M_VERGL_094:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_090
        RJMP       M_IF_091
M_IF_090:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_092
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_091:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_092:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (HEXLOW) retten
        MOV        R17, R1
 
; lokalen Parameter (HEXLOW) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x48
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (SENDE_HEX_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (SENDE_HEX_ZEICHEN_LN)
SENDE_HEX_ZEICHEN_LN:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Aufruf PROCEDURE (SENDE_HEX_ZEICHEN)
        CALL       SENDE_HEX_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; PROCEDURE - Ende (SENDE_HEX_ZEICHEN_LN)
        RET
 
; PROCEDURE - Anfang (WRITE_SER)
WRITE_SER:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_095:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_096
        RJMP       M_FTD_097
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_096:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_SER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_SER)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_095
 
; FOR TO DO - Ende
M_FTD_097:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_SER)
        RET
 
; PROCEDURE - Anfang (WRITELN_SER)
WRITELN_SER:
 
; Aufruf PROCEDURE (WRITE_SER)
        CALL       WRITE_SER
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; PROCEDURE - Ende (WRITELN_SER)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFC)
        LDI        R16, 0xFC
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (PROCEDURE_A)
PROCEDURE_A:
 
; SetBit(LED_GELB)
        SBI        PORTB, 5
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('a gedrueckt')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_098
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_098:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0100
M_PRG_CONST_STRING_099:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_099
M_PRG_CONST_STRING_0100:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0102
        MOV        R16, R17
M_PRG_CONST_STRING_0101:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0101
M_PRG_CONST_STRING_0102:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER)
        CALL       WRITELN_SER
 
; PROCEDURE - Ende (PROCEDURE_A)
        RET
 
; PROCEDURE - Anfang (PROCEDURE_B)
PROCEDURE_B:
 
; ClearBit(LED_GELB)
        CBI        PORTB, 5
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('b gedrueckt')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0103
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0103:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0105
M_PRG_CONST_STRING_0104:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0104
M_PRG_CONST_STRING_0105:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0107
        MOV        R16, R17
M_PRG_CONST_STRING_0106:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0106
M_PRG_CONST_STRING_0107:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER)
        CALL       WRITELN_SER
 
; PROCEDURE - Ende (PROCEDURE_B)
        RET
 
; PROCEDURE - Anfang (PROCEDURE_C)
PROCEDURE_C:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('c gedrueckt')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0108
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0108:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0110
M_PRG_CONST_STRING_0109:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0109
M_PRG_CONST_STRING_0110:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0112
        MOV        R16, R17
M_PRG_CONST_STRING_0111:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0111
M_PRG_CONST_STRING_0112:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER)
        CALL       WRITELN_SER
 
; PROCEDURE - Ende (PROCEDURE_C)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_AUSWERTEN)
STEUER_STRING_AUSWERTEN:
 
; Zuweisung Quelle - Ausdruck / Length(STEUER_STRING)
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0116
        CLR        R16
        RJMP       M_VERGL_0117
M_VERGL_0116:
        SER        R16
M_VERGL_0117:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0113
        RJMP       M_IF_0114
M_IF_0113:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (a)
        CPI        R16, 'a'
        BREQ       M_CASE_0120
        RJMP       M_CASE_0119
M_CASE_0120:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0124
        CLR        R16
        RJMP       M_VERGL_0125
M_VERGL_0124:
        SER        R16
M_VERGL_0125:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0121
        RJMP       M_IF_0122
M_IF_0121:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (PROCEDURE_A)
        CALL       PROCEDURE_A
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0123
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0122:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x01')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0126
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0126:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0128
M_PRG_CONST_STRING_0127:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0127
M_PRG_CONST_STRING_0128:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0130
        MOV        R16, R17
M_PRG_CONST_STRING_0129:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0129
M_PRG_CONST_STRING_0130:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER)
        CALL       WRITELN_SER
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0123:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0118
M_CASE_0119:
 
; CASE OF - vergleiche Einzel-Element (b)
        CPI        R16, 'b'
        BREQ       M_CASE_0132
        RJMP       M_CASE_0131
M_CASE_0132:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0136
        CLR        R16
        RJMP       M_VERGL_0137
M_VERGL_0136:
        SER        R16
M_VERGL_0137:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0133
        RJMP       M_IF_0134
M_IF_0133:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (PROCEDURE_B)
        CALL       PROCEDURE_B
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0135
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0134:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x02')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0138
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0138:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0140
M_PRG_CONST_STRING_0139:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0139
M_PRG_CONST_STRING_0140:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0142
        MOV        R16, R17
M_PRG_CONST_STRING_0141:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0141
M_PRG_CONST_STRING_0142:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER)
        CALL       WRITELN_SER
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0135:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0118
M_CASE_0131:
 
; CASE OF - vergleiche Einzel-Element (c)
        CPI        R16, 'c'
        BREQ       M_CASE_0144
        RJMP       M_CASE_0143
M_CASE_0144:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0148
        CLR        R16
        RJMP       M_VERGL_0149
M_VERGL_0148:
        SER        R16
M_VERGL_0149:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0145
        RJMP       M_IF_0146
M_IF_0145:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (PROCEDURE_C)
        CALL       PROCEDURE_C
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0147
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0146:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x03')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0150
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0150:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0152
M_PRG_CONST_STRING_0151:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0151
M_PRG_CONST_STRING_0152:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0154
        MOV        R16, R17
M_PRG_CONST_STRING_0153:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0153
M_PRG_CONST_STRING_0154:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER)
        CALL       WRITELN_SER
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0147:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0118
 
; CASE OF ELSE
M_CASE_0143:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x09')
        LDI        ZL, LOW(2*M_CONST_STRING_6)
        LDI        ZH, HIGH(2*M_CONST_STRING_6)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0155
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0155:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0157
M_PRG_CONST_STRING_0156:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0156
M_PRG_CONST_STRING_0157:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0159
        MOV        R16, R17
M_PRG_CONST_STRING_0158:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0158
M_PRG_CONST_STRING_0159:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER)
        CALL       WRITELN_SER
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0118:
 
; IF_THEN - Ende
M_IF_0114:
 
; PROCEDURE - Ende (STEUER_STRING_AUSWERTEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_LESEN)
STEUER_STRING_LESEN:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER_ZEICHEN)
        LDS        R16, SER_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0D)
        LDI        R18, 0x0D
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0163
        CLR        R16
        RJMP       M_VERGL_0164
M_VERGL_0163:
        SER        R16
M_VERGL_0164:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0160
        RJMP       M_IF_0161
M_IF_0160:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER_ZEICHEN)
        LDS        R16, SER_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0A)
        LDI        R18, 0x0A
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0168
        CLR        R16
        RJMP       M_VERGL_0169
M_VERGL_0168:
        SER        R16
M_VERGL_0169:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0165
        RJMP       M_IF_0166
M_IF_0165:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_LESEN)
        PUSH       R0
 
; Aufruf PROCEDURE (STEUER_STRING_AUSWERTEN)
        CALL       STEUER_STRING_AUSWERTEN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_LESEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_7)
        LDI        ZH, HIGH(2*M_CONST_STRING_7)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0170
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0170:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0172
M_PRG_CONST_STRING_0171:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0171
M_PRG_CONST_STRING_0172:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0174
        MOV        R16, R17
M_PRG_CONST_STRING_0173:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0173
M_PRG_CONST_STRING_0174:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0167
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0166:
 
; Zuweisung Quelle - Ausdruck / Char-VAR (SER_ZEICHEN)
        LDS        R16, SER_ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0175
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0175:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0177
M_PRG_CONST_STRING_0176:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0176
M_PRG_CONST_STRING_0177:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0178
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0178:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0180
        MOV        R16, R17
M_PRG_CONST_STRING_0179:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0179
M_PRG_CONST_STRING_0180:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0167:
 
; IF_THEN - Ende
M_IF_0161:
 
; PROCEDURE - Ende (STEUER_STRING_LESEN)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_SER_PORT)
        CALL       INIT_SER_PORT
 
; LOOP - Start_Marke
M_LOOP_0181:
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER_ZEICHEN)
        LDS        R16, SER_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0185
        CLR        R16
        RJMP       M_VERGL_0186
M_VERGL_0185:
        SER        R16
M_VERGL_0186:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0182
        RJMP       M_IF_0183
M_IF_0182:
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; IF_THEN - Ende
M_IF_0183:
 
; LOOP - Ende
        RJMP       M_LOOP_0181
 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; TAKTFREQUENZ (C) WORD Wert=0x3E80
; UBRR_VAL (C) BYTE Wert=0x19
; LED_GELB (B) BIT
; STEUER_STRING (V) STRING
; WAITKON (C) WORD Wert=0x0010
; WAITKON2 (C) WORD Wert=0x02D0
; WRITE_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; SER_ZEICHEN (V) BYTE
; INIT_SER_PORT (P) 
; RX_PUFFER_ABFRAGEN (P) 
; SENDE_ZEICHEN (P) 
; SENDE_HEX_ZEICHEN (P) 
; SENDE_HEX_ZEICHEN_LN (P) 
; WRITE_SER (P) 
; WRITELN_SER (P) 
; INITPORTS (P) 
; PROCEDURE_A (P) 
; PROCEDURE_B (P) 
; PROCEDURE_C (P) 
; STEUER_STRING_AUSWERTEN (P) 
; STEUER_STRING_LESEN (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE INIT_SER_PORT;
; PROCEDURE RX_PUFFER_ABFRAGEN;
; PROCEDURE SENDE_ZEICHEN (S_ZEICHEN : BYTE);
; PROCEDURE SENDE_HEX_ZEICHEN (H_ZEICHEN : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE);
; PROCEDURE SENDE_HEX_ZEICHEN_LN (WERT_BYTE : BYTE);
; PROCEDURE WRITE_SER (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN_SER;
; PROCEDURE INITPORTS;
; PROCEDURE PROCEDURE_A;
; PROCEDURE PROCEDURE_B;
; PROCEDURE PROCEDURE_C;
; PROCEDURE STEUER_STRING_AUSWERTEN (BUCHSTABE : CHAR) (ZEICHEN_1 : CHAR) (ZEICHEN_2 : CHAR) (LAENGE : BYTE);
; PROCEDURE STEUER_STRING_LESEN (AKT_ZEICHEN : CHAR);
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    11, "a gedrueckt"
 
M_CONST_STRING_1:
 .db    11, "b gedrueckt"
 
M_CONST_STRING_2:
 .db    11, "c gedrueckt"
 
M_CONST_STRING_3:
 .db    3, "x01"
 
M_CONST_STRING_4:
 .db    3, "x02"
 
M_CONST_STRING_5:
 .db    3, "x03"
 
M_CONST_STRING_6:
 .db    3, "x09"
 
M_CONST_STRING_7:
 .db    0, " "
 
