
// ****************************
// *** ITP3-Client-Routinen ***
// *** Hardware-Teil        ***
// ****************************



VAR

{
C0..C3 - D0..D3 - ITP3-Daten
C4 - DS - Device Select
C5 - DR - Device Receive
}
  // Ausgangs-Definitionen
  D0_A[PortF,0] : bit; // D0 - Ausgang
  D1_A[PortF,1] : bit; // D1 - Ausgang
  D2_A[PortF,2] : bit; // D2 - Ausgang
  D3_A[PortF,3] : bit; // D3 - Ausgang
  DR_A[PortF,5] : bit; // DR - Device Receive - Ausgang

  // Port-Richtungs-Definitionen (E/A)
  D0_D[DDRF,0] : bit;  // D0 - Ein-/Ausgang (Direction)
  D1_D[DDRF,1] : bit;  // D1 - Ein-/Ausgang (Direction)
  D2_D[DDRF,2] : bit;  // D2 - Ein-/Ausgang (Direction)
  D3_D[DDRF,3] : bit;  // D3 - Ein-/Ausgang (Direction)
  DR_D[DDRF,5] : bit;  // DR - Device Receive (Direction)

  // Eingangs-Definitionen
  D0_E[PinF,0] : bit;  // D0 - Eingang
  D1_E[PinF,1] : bit;  // D1 - Eingang
  D2_E[PinF,2] : bit;  // D2 - Eingang
  D3_E[PinF,3] : bit;  // D3 - Eingang
  DR_E[PinF,5] : bit;  // DR - Device Receive - Eingang



  // DS fuer Client 1
  DS_A[PortF,4] : bit; // DS - Device Select - Ausgang
  DS_D[DDRF,4] : bit;  // DS - Device Select (Direction)
  DS_E[PinF,4] : bit;  // DS - Device Select - Eingang


  LED_BL_D[DDRF,6] : bit; // LED Blau Direction
  LED_BL[PortF, 6] : bit; // LED Blau Ausgang

  LED_RT_D[DDRF,7] : bit; // LED Rot Direction
  LED_RT[PortF, 7] : bit; // LED Rot Ausgang



