
// ****************************
// *** ITP3-Client-Routinen ***
// *** Hardware-Teil        ***
// ****************************



VAR

{
A0..A3 - D0..D3 - ITP3-Daten
A4 - DS - Device Select
A5 - DR - Device Receive
}
  // Ausgangs-Definitionen
  D0_A[PortA,0] : bit; // D0 - Ausgang
  D1_A[PortA,1] : bit; // D1 - Ausgang
  D2_A[PortA,2] : bit; // D2 - Ausgang
  D3_A[PortA,3] : bit; // D3 - Ausgang
  DR_A[PortA,5] : bit; // DR - Device Receive - Ausgang

  // Port-Richtungs-Definitionen (E/A)
  D0_D[DDRA,0] : bit;  // D0 - Ein-/Ausgang (Direction)
  D1_D[DDRA,1] : bit;  // D1 - Ein-/Ausgang (Direction)
  D2_D[DDRA,2] : bit;  // D2 - Ein-/Ausgang (Direction)
  D3_D[DDRA,3] : bit;  // D3 - Ein-/Ausgang (Direction)
  DR_D[DDRA,5] : bit;  // DR - Device Receive (Direction)

  // Eingangs-Definitionen
  D0_E[PinA,0] : bit;  // D0 - Eingang
  D1_E[PinA,1] : bit;  // D1 - Eingang
  D2_E[PinA,2] : bit;  // D2 - Eingang
  D3_E[PinA,3] : bit;  // D3 - Eingang
  DR_E[PinA,5] : bit;  // DR - Device Receive - Eingang



  // DS fuer Client 1
  DS_A[PortA,4] : bit; // DS - Device Select - Ausgang
  DS_D[DDRA,4] : bit;  // DS - Device Select (Direction)
  DS_E[PinA,4] : bit;  // DS - Device Select - Eingang


  LED_BL_D[DDRA,6] : bit; // LED Blau Direction
  LED_BL[PortA, 6] : bit; // LED Blau Ausgang

  LED_RT_D[DDRA,7] : bit; // LED Rot Direction
  LED_RT[PortA, 7] : bit; // LED Rot Ausgang



