
  SetBit(DIR);

  DDRA:=  %00000000;
  SetBit(WE);
  SetBit(OE);


  ASM;


; Vereinbarungsteil
; -----------------
.EQU  C_A16 = 2
.EQU  C_WE  = 3
.EQU  C_OE  = 4
.EQU  C_DIR = 6

; Voreinstellungen
; ----------------

      ; Loeschen von A16
      CBI    PORTD, C_A16



      ; R19=0 (Eingang)
      CLR    R19

      ; R20=FF (Ausgang)
      SER    R20
 

      CALL   ScreenRoll1_ANF

      CALL   ScreenRoll2_ANF

      ; Setzen von A16
      SBI    PORTD, C_A16

      CALL   ScreenRoll1_ANF

      RJMP   ScreenRoll_END

; -----------------------------

ScreenRoll1_ANF:
      
      ; R17 = Y_POS_Ziel
      CLR    R17 

      ; R18 = Y_POS_Quelle
      LDI    R18, 20 

ScreenRoll1_Y:

      ; R16 = X_POS
      CLR    R16

ScreenRoll1_X:

      ; Setzen der Y-Speicheradresse (Y_POS_Quelle)
      OUT    PORTC, R18

      ; Setzen der X-Speicheradresse 
      OUT    PORTB, R16

      ; SRAM OUTPUT ENABLE
      CBI    PORTD, C_OE


      NOP
      NOP
      NOP
      NOP

      ; X_POS + 1
      INC     R16


      ; READ DATA BYTE
      IN     R21 ,PINA

      ; SRAM OUTPUT DISABLE
      SBI    PORTD, C_OE

     ; Setzen der Y-Speicheradresse (Y_POS_Ziel)
      OUT    PORTC, R17

     ; DIR auf Schreiben
      CBI    PORTD, C_DIR

      ; Daten-Port auf Ausgang programmieren
      OUT    DDRA, R20

     ; Ausgabe des Farbbytes fuer den Pixel an den Datenport des SRAM 
     OUT     PORTA, R21

     ; und Uebernahme des Wertes in den RAM durch aktivieren von WE
     CBI     PORTD, C_WE 

     NOP
     NOP
     NOP
     NOP
     NOP
     NOP

     SBI     PORTD, C_WE 

      ; Daten-Port auf Eingang programmieren
      OUT    DDRA, R19

    ; DIR auf Lesen
      SBI    PORTD, C_DIR

     ; XEND erreicht
     CP      R16, R19

     ; Wenn nicht, X-Schleife nochmal durchlaufen
     BRNE    ScreenRoll1_X

     ;
     INC     R17
     INC     R18

     ; YEND erreicht
     CP      R18, R19

    ; Wenn nicht, Y-Schleife nochmal durchlaufen
     BRNE    ScreenRoll1_Y

    ; Ruecksprung
    RET




ScreenRoll2_ANF:
      
      ; R17 = Y_POS_Ziel
      LDI    R17, 236 

      ; R18 = Y_POS_Quelle
      CLR    R18 


ScreenRoll2_Y:

      ; R16 = X_POS
      CLR    R16

ScreenRoll2_X:

      ; Setzen von A16
      SBI    PORTD, C_A16

      ; Setzen der Y-Speicheradresse (Y_POS_Quelle)
      OUT    PORTC, R18

      ; Setzen der X-Speicheradresse 
      OUT    PORTB, R16

      ; SRAM OUTPUT ENABLE
      CBI    PORTD, C_OE


      NOP
      NOP
      NOP
      NOP

      ; X_POS + 1
      INC     R16


      ; READ DATA BYTE
      IN     R21 ,PINA

      ; SRAM OUTPUT DISABLE
      SBI    PORTD, C_OE


      ; Loeschen von A16
      CBI    PORTD, C_A16


     ; Setzen der Y-Speicheradresse (Y_POS_Ziel)
      OUT    PORTC, R17

     ; DIR auf Schreiben
      CBI    PORTD, C_DIR

      ; Daten-Port auf Ausgang programmieren
      OUT    DDRA, R20

     ; Ausgabe des Farbbytes fuer den Pixel an den Datenport des SRAM 
     OUT     PORTA, R21

     ; und Uebernahme des Wertes in den RAM durch aktivieren von WE
     CBI     PORTD, C_WE 

     NOP
     NOP
     NOP
     NOP
     NOP
     NOP

     SBI     PORTD, C_WE 

      ; Daten-Port auf Eingang programmieren
      OUT    DDRA, R19

    ; DIR auf Lesen
      SBI    PORTD, C_DIR

     ; XEND erreicht
     CP      R16, R19

     ; Wenn nicht, X-Schleife nochmal durchlaufen
     BRNE    ScreenRoll2_X

     ;
     INC     R17
     INC     R18

     ; YEND erreicht
     CP      R17, R19

    ; Wenn nicht, Y-Schleife nochmal durchlaufen
     BRNE    ScreenRoll2_Y

    ; Ruecksprung
    RET




ScreenRoll_END:



  ENDASM;

  SetBit(WE);

  DDRA:= %00000000;
  SetBit(DIR);

  SetBit(OE);
  ClearBit(A16);



