; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: SOUND.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        SND_KEIN_BEFEHL  =  0x00 ; BYTE
.equ        SND_RESET_LIED_TAB  =  0x01 ; BYTE
.equ        SND_LADE_LIED_TAB  =  0x02 ; BYTE
.equ        SND_SPIELE_LIED_TAB  =  0x03 ; BYTE
.equ        SND_SETZE_MIDI  =  0x04 ; BYTE
.equ        SND_SETZE_DAUER  =  0x05 ; BYTE
.equ        SND_SETZE_INSTR  =  0x06 ; BYTE
.equ        SND_SPIELE_SAVE_TAB  =  0x0C ; BYTE
.equ        INSTR_KIRCHENORGEL  =  0x00 ; BYTE
.equ        INSTR_SINUS  =  0x01 ; BYTE
.equ        BA_MODE_KEINEBA  =  0x00 ; BYTE
.equ        BA_MODE_INI  =  0x01 ; BYTE
.equ        BA_MODE_SET_WR  =  0x02 ; BYTE
.equ        BA_MODE_WR  =  0x03 ; BYTE
.equ        BA_MODE_SET_RD  =  0x04 ; BYTE
.equ        BA_MODE_RD  =  0x05 ; BYTE
.equ        NO_RECEIVE_MODE  =  0x00 ; BYTE
.equ        RECEIVE_SOUND  =  0x01 ; BYTE
.equ        RECEIVE_DEVCODE  =  0x02 ; BYTE
.equ        RECEIVE_ERROR_CODE  =  0x03 ; BYTE
.equ        NO_SEND_MODE  =  0x00 ; BYTE
.equ        SEND_SOUND  =  0x01 ; BYTE
.equ        RE_CONST  =  0x01 ; BYTE
.equ        RE_CONIN  =  0x02 ; BYTE
.equ        SE_CONOUT  =  0x03 ; BYTE
.equ        RE_SECNT  =  0x04 ; BYTE
.equ        RE_SECTOR  =  0x05 ; BYTE
.equ        RE_RD_ISEC  =  0x06 ; BYTE
.equ        SE_WR_ISEC  =  0x07 ; BYTE
.equ        SE_STD  =  0x08 ; BYTE
.equ        SE_LIST  =  0x09 ; BYTE
.equ        RE_ERROR_CODE  =  0x0A ; BYTE
.equ        SE_SOUND  =  0x0F ; BYTE
.equ        RE_WHO_ARE_YOU  =  0x14 ; BYTE
.equ        DEVCODE_PC_CPM_EMU  =  0x02 ; BYTE
.equ        DEVCODE_KEYBOARD  =  0x03 ; BYTE
.equ        DEVCODE_DISPLAY  =  0x04 ; BYTE
.equ        DEVCODE_RAMFLOPPY  =  0x05 ; BYTE
.equ        DEVCODE_CONINOUT  =  0x06 ; BYTE
.equ        DEVCODE_SOUND  =  0x07 ; BYTE
.equ        MESSAGE_WHO_AM_I  =  0x07 ; BYTE
.equ        LIED_TAB2_LAENGE  =  0x001F ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
ZAEHLER_T0:   ; Word
.byte     2
ZAEHLER_T1:   ; Word
.byte     2
TON_PERIODE:   ; Word
.byte     2
MIDI_NUMMER:   ; Word
.byte     2
LIED_TAB_ZEIGER:   ; Word
.byte     2
TON_DAUER:   ; Word
.byte     2
LIED_TAB_LAENGE:   ; Word
.byte     2
SIN_WERT:   ; Byte
.byte     1
TON_DAUER_BYTE:   ; Byte
.byte     1
MIDI_NUMMER_BYTE:   ; Byte
.byte     1
BA_MODE:   ; Byte
.byte     1
RECEIVE_MODE:   ; Byte
.byte     1
SEND_MODE:   ; Byte
.byte     1
ERROR_CODE:   ; Byte
.byte     1
ERROR_PARAM:   ; Byte
.byte     1
SOUND_BYTE:   ; Byte
.byte     1
LADE_BYTE:   ; Byte
.byte     1
SOUND_BEFEHL:   ; Byte
.byte     1
ARRAY_ADRESSE:   ; Adresse
.byte     2
 
LIED_TAB:
.byte     512
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Timer/Counter2 Overflow
.ORG OVF2addr
        JMP        TIMER2_OVF
 
; Timer/Counter1 Compare Match A
.ORG OC1Aaddr
        JMP        TIMER1_COMPA
 
; Timer/Counter0 Overflow
.ORG OVF0addr
        JMP        TIMER0_OVF
 
; PROCEDURE - Anfang (TIMER0_AUS)
TIMER0_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; PROCEDURE - Ende (TIMER0_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER0_OVF)
INIT_TIMER0_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIFR0)
        OUT        TIFR0, R16
 
; PROCEDURE - Ende (INIT_TIMER0_OVF)
        RET
 
; PROCEDURE - Anfang (TIMER1_AUS)
TIMER1_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (TIMER1_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_COMPA)
INIT_TIMER1_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (OCR1AH)
        STS        OCR1AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (OCR1AL)
        STS        OCR1AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (INIT_TIMER1_COMPA)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER2_OVF)
INIT_TIMER2_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR2A)
        STS        TCCR2A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TCCR2B)
        STS        TCCR2B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ASSR)
        STS        ASSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK2)
        STS        TIMSK2, R16
 
; PROCEDURE - Ende (INIT_TIMER2_OVF)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG DDRB
        IN         R16, DDRB
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x05)
        LDI        R18, 0x05
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (INITADRESSEN)
INITADRESSEN:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(SINTAB)
        LDI        R16, LOW(2*SINTAB)
        LDI        R17, HIGH(2*SINTAB)
 
; Zuweisung Ziel /  VAR (ARRAY_ADRESSE)
        STS        ARRAY_ADRESSE, R16
        STS        ARRAY_ADRESSE+1, R17
 
; PROCEDURE - Ende (INITADRESSEN)
        RET
 
; PROCEDURE - Anfang (LESE_SOUND_BYTE)
LESE_SOUND_BYTE:
 
; CASE OF - Byte-VAR (SOUND_BEFEHL)
        LDS        R16, SOUND_BEFEHL
 
; CASE OF - vergleiche Einzel-Element (SND_KEIN_BEFEHL)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SOUND_BYTE)
        LDS        R16, SOUND_BYTE
 
; Zuweisung Ziel /  VAR (SOUND_BEFEHL)
        STS        SOUND_BEFEHL, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (SND_SETZE_MIDI)
        CPI        R16, 0x04
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (LIED_TAB_LAENGE)
        LDS        R16, LIED_TAB_LAENGE
        LDS        R17, LIED_TAB_LAENGE+1
 
; VAR ARRAY Ziel Zeiger berechnen (LIED_TAB)
        LDI        ZL, LOW(LIED_TAB)
        LDI        ZH, HIGH(LIED_TAB)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SOUND_BYTE)
        LDS        R16, SOUND_BYTE
 
; Zuweisung Ziel /  VAR ARRAY (LIED_TAB)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(LIED_TAB_LAENGE) - Word
        LDS        R24, LIED_TAB_LAENGE
        LDS        R25, LIED_TAB_LAENGE+1
        ADIW       R25:R24, 1
        STS        LIED_TAB_LAENGE, R24
        STS        LIED_TAB_LAENGE+1, R25
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SND_SETZE_DAUER)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (SOUND_BEFEHL)
        STS        SOUND_BEFEHL, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (SND_SETZE_DAUER)
        CPI        R16, 0x05
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (LIED_TAB_LAENGE)
        LDS        R16, LIED_TAB_LAENGE
        LDS        R17, LIED_TAB_LAENGE+1
 
; VAR ARRAY Ziel Zeiger berechnen (LIED_TAB)
        LDI        ZL, LOW(LIED_TAB)
        LDI        ZH, HIGH(LIED_TAB)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SOUND_BYTE)
        LDS        R16, SOUND_BYTE
 
; Zuweisung Ziel /  VAR ARRAY (LIED_TAB)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(LIED_TAB_LAENGE) - Word
        LDS        R24, LIED_TAB_LAENGE
        LDS        R25, LIED_TAB_LAENGE+1
        ADIW       R25:R24, 1
        STS        LIED_TAB_LAENGE, R24
        STS        LIED_TAB_LAENGE+1, R25
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SND_KEIN_BEFEHL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SOUND_BEFEHL)
        STS        SOUND_BEFEHL, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (SND_SETZE_INSTR)
        CPI        R16, 0x06
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (LIED_TAB_LAENGE)
        LDS        R16, LIED_TAB_LAENGE
        LDS        R17, LIED_TAB_LAENGE+1
 
; VAR ARRAY Ziel Zeiger berechnen (LIED_TAB)
        LDI        ZL, LOW(LIED_TAB)
        LDI        ZH, HIGH(LIED_TAB)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR ARRAY (LIED_TAB)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(LIED_TAB_LAENGE) - Word
        LDS        R24, LIED_TAB_LAENGE
        LDS        R25, LIED_TAB_LAENGE+1
        ADIW       R25:R24, 1
        STS        LIED_TAB_LAENGE, R24
        STS        LIED_TAB_LAENGE+1, R25
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (LIED_TAB_LAENGE)
        LDS        R16, LIED_TAB_LAENGE
        LDS        R17, LIED_TAB_LAENGE+1
 
; VAR ARRAY Ziel Zeiger berechnen (LIED_TAB)
        LDI        ZL, LOW(LIED_TAB)
        LDI        ZH, HIGH(LIED_TAB)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SOUND_BYTE)
        LDS        R16, SOUND_BYTE
 
; Zuweisung Ziel /  VAR ARRAY (LIED_TAB)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(LIED_TAB_LAENGE) - Word
        LDS        R24, LIED_TAB_LAENGE
        LDS        R25, LIED_TAB_LAENGE+1
        ADIW       R25:R24, 1
        STS        LIED_TAB_LAENGE, R24
        STS        LIED_TAB_LAENGE+1, R25
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SND_KEIN_BEFEHL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SOUND_BEFEHL)
        STS        SOUND_BEFEHL, R16
 
; ENDCASE;
M_CASE_08:
M_CASE_01:
 
; CASE OF - Byte-VAR (SOUND_BEFEHL)
        LDS        R16, SOUND_BEFEHL
 
; CASE OF - vergleiche Einzel-Element (SND_RESET_LIED_TAB)
        CPI        R16, 0x01
        BREQ       M_CASE_012
        RJMP       M_CASE_011
M_CASE_012:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (LIED_TAB_LAENGE)
        STS        LIED_TAB_LAENGE, R16
        STS        LIED_TAB_LAENGE+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (LESE_SOUND_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (TIMER1_AUS)
        CALL       TIMER1_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (LESE_SOUND_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LESE_SOUND_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (TIMER0_AUS)
        CALL       TIMER0_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (LESE_SOUND_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SND_KEIN_BEFEHL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SOUND_BEFEHL)
        STS        SOUND_BEFEHL, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_010
M_CASE_011:
 
; CASE OF - vergleiche Einzel-Element (SND_SPIELE_LIED_TAB)
        CPI        R16, 0x03
        BREQ       M_CASE_014
        RJMP       M_CASE_013
M_CASE_014:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (LIED_TAB_ZEIGER)
        STS        LIED_TAB_ZEIGER, R16
        STS        LIED_TAB_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER_T0)
        STS        ZAEHLER_T0, R16
        STS        ZAEHLER_T0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (TON_DAUER)
        STS        TON_DAUER, R16
        STS        TON_DAUER+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (LESE_SOUND_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (TIMER1_AUS)
        CALL       TIMER1_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (LESE_SOUND_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LESE_SOUND_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (INIT_TIMER0_OVF)
        CALL       INIT_TIMER0_OVF
 
; Retten der Parameter-Register fuer PROCEDURE (LESE_SOUND_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SND_KEIN_BEFEHL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SOUND_BEFEHL)
        STS        SOUND_BEFEHL, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_010
M_CASE_013:
 
; CASE OF - vergleiche Einzel-Element (SND_SPIELE_SAVE_TAB)
        CPI        R16, 0x0C
        BREQ       M_CASE_016
        RJMP       M_CASE_015
M_CASE_016:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LIED_TAB2_LAENGE)
        LDI        R16, LOW(0x001F)
        LDI        R17, HIGH(0x001F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_017:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_018
        RJMP       M_FTD_019
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_018:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (LIED_TAB2)
        LDI        ZL, LOW(2*LIED_TAB2)
        LDI        ZH, HIGH(2*LIED_TAB2)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (LIED_TAB)
        LDI        ZL, LOW(LIED_TAB)
        LDI        ZH, HIGH(LIED_TAB)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY (LIED_TAB)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_017
 
; FOR TO DO - Ende
M_FTD_019:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (LIED_TAB2_LAENGE)
        LDI        R16, LOW(0x001F)
        LDI        R17, HIGH(0x001F)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (LIED_TAB_LAENGE)
        STS        LIED_TAB_LAENGE, R16
        STS        LIED_TAB_LAENGE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (LIED_TAB_ZEIGER)
        STS        LIED_TAB_ZEIGER, R16
        STS        LIED_TAB_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER_T0)
        STS        ZAEHLER_T0, R16
        STS        ZAEHLER_T0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (TON_DAUER)
        STS        TON_DAUER, R16
        STS        TON_DAUER+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (LESE_SOUND_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (TIMER1_AUS)
        CALL       TIMER1_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (LESE_SOUND_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LESE_SOUND_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (INIT_TIMER0_OVF)
        CALL       INIT_TIMER0_OVF
 
; Retten der Parameter-Register fuer PROCEDURE (LESE_SOUND_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SND_KEIN_BEFEHL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SOUND_BEFEHL)
        STS        SOUND_BEFEHL, R16
 
; ENDCASE;
M_CASE_015:
M_CASE_010:
 
; PROCEDURE - Ende (LESE_SOUND_BYTE)
        RET
 
; ISR - Einsprung
TIMER0_OVF:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCNT0)
        OUT        TCNT0, R16
 
; INC(ZAEHLER_T0) - Word
        LDS        R24, ZAEHLER_T0
        LDS        R25, ZAEHLER_T0+1
        ADIW       R25:R24, 1
        STS        ZAEHLER_T0, R24
        STS        ZAEHLER_T0+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (ZAEHLER_T0)
        LDS        R16, ZAEHLER_T0
        LDS        R17, ZAEHLER_T0+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (TON_DAUER)
        LDS        R18, TON_DAUER
        LDS        R19, TON_DAUER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_023
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_024
M_VERGL_023:
        SER        R16
M_VERGL_024:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_020
        RJMP       M_IF_021
M_IF_020:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER_T0)
        STS        ZAEHLER_T0, R16
        STS        ZAEHLER_T0+1, R17
 
; ARRAY - Ausdruck / Word-VAR (LIED_TAB_ZEIGER)
        LDS        R16, LIED_TAB_ZEIGER
        LDS        R17, LIED_TAB_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LIED_TAB)
        LDI        ZL, LOW(LIED_TAB)
        LDI        ZH, HIGH(LIED_TAB)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (MIDI_NUMMER_BYTE)
        STS        MIDI_NUMMER_BYTE, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(MIDI_NUMMER_BYTE)
        LDS        R16, MIDI_NUMMER_BYTE
        CLR        R17
 
; Zuweisung Ziel /  VAR (MIDI_NUMMER)
        STS        MIDI_NUMMER, R16
        STS        MIDI_NUMMER+1, R17
 
; INC(LIED_TAB_ZEIGER) - Word
        LDS        R24, LIED_TAB_ZEIGER
        LDS        R25, LIED_TAB_ZEIGER+1
        ADIW       R25:R24, 1
        STS        LIED_TAB_ZEIGER, R24
        STS        LIED_TAB_ZEIGER+1, R25
 
; ARRAY - Ausdruck / Word-VAR (LIED_TAB_ZEIGER)
        LDS        R16, LIED_TAB_ZEIGER
        LDS        R17, LIED_TAB_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LIED_TAB)
        LDI        ZL, LOW(LIED_TAB)
        LDI        ZH, HIGH(LIED_TAB)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (TON_DAUER_BYTE)
        STS        TON_DAUER_BYTE, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(TON_DAUER_BYTE)
        LDS        R16, TON_DAUER_BYTE
        CLR        R17
 
; Zuweisung Ziel /  VAR (TON_DAUER)
        STS        TON_DAUER, R16
        STS        TON_DAUER+1, R17
 
; INC(LIED_TAB_ZEIGER) - Word
        LDS        R24, LIED_TAB_ZEIGER
        LDS        R25, LIED_TAB_ZEIGER+1
        ADIW       R25:R24, 1
        STS        LIED_TAB_ZEIGER, R24
        STS        LIED_TAB_ZEIGER+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (LIED_TAB_ZEIGER)
        LDS        R16, LIED_TAB_ZEIGER
        LDS        R17, LIED_TAB_ZEIGER+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (LIED_TAB_LAENGE)
        LDS        R18, LIED_TAB_LAENGE
        LDS        R19, LIED_TAB_LAENGE+1
 
; Operator >=
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_VERGL_028
        CLR        R16
        RJMP       M_VERGL_029
M_VERGL_028:
        SER        R16
M_VERGL_029:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_025
        RJMP       M_IF_026
M_IF_025:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (LIED_TAB_ZEIGER)
        STS        LIED_TAB_ZEIGER, R16
        STS        LIED_TAB_ZEIGER+1, R17
 
; Aufruf PROCEDURE (TIMER0_AUS)
        CALL       TIMER0_AUS
 
; Aufruf PROCEDURE (TIMER1_AUS)
        CALL       TIMER1_AUS
 
; IF_THEN - Ende
M_IF_026:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER_T1)
        STS        ZAEHLER_T1, R16
        STS        ZAEHLER_T1+1, R17
 
; CASE OF - Byte-VAR (MIDI_NUMMER_BYTE)
        LDS        R16, MIDI_NUMMER_BYTE
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; Aufruf PROCEDURE (TIMER1_AUS)
        CALL       TIMER1_AUS
 
; ClearBit(LED_ROT)
        CBI        PORTB, 0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_030
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; CASE OF - Byte-VAR (TON_DAUER_BYTE)
        LDS        R16, TON_DAUER_BYTE
 
; CASE OF - vergleiche Einzel-Element (INSTR_KIRCHENORGEL)
        CPI        R16, 0x00
        BREQ       M_CASE_037
        RJMP       M_CASE_036
M_CASE_037:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(PIPE_ORGAN_TAB)
        LDI        R16, LOW(2*PIPE_ORGAN_TAB)
        LDI        R17, HIGH(2*PIPE_ORGAN_TAB)
 
; Zuweisung Ziel /  VAR (ARRAY_ADRESSE)
        STS        ARRAY_ADRESSE, R16
        STS        ARRAY_ADRESSE+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_035
M_CASE_036:
 
; CASE OF - vergleiche Einzel-Element (INSTR_SINUS)
        CPI        R16, 0x01
        BREQ       M_CASE_039
        RJMP       M_CASE_038
M_CASE_039:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(SINTAB)
        LDI        R16, LOW(2*SINTAB)
        LDI        R17, HIGH(2*SINTAB)
 
; Zuweisung Ziel /  VAR (ARRAY_ADRESSE)
        STS        ARRAY_ADRESSE, R16
        STS        ARRAY_ADRESSE+1, R17
 
; ENDCASE;
M_CASE_038:
M_CASE_035:
 
; Aufruf PROCEDURE (TIMER1_AUS)
        CALL       TIMER1_AUS
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (TON_DAUER)
        STS        TON_DAUER, R16
        STS        TON_DAUER+1, R17
 
; ClearBit(LED_ROT)
        CBI        PORTB, 0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_030
 
; CASE OF ELSE
M_CASE_033:
 
; ARRAY - Ausdruck / Word-VAR (MIDI_NUMMER)
        LDS        R16, MIDI_NUMMER
        LDS        R17, MIDI_NUMMER+1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (MIDI_TAB)
        LDI        ZL, LOW(2*MIDI_TAB)
        LDI        ZH, HIGH(2*MIDI_TAB)
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z+
        LPM        R17, Z+
 
; Zuweisung Ziel /  VAR (TON_PERIODE)
        STS        TON_PERIODE, R16
        STS        TON_PERIODE+1, R17
 
; Word-Parameter(1) fuer PROCEDURE (INIT_TIMER1_COMPA)
        LDS        R0, TON_PERIODE
        LDS        R1, TON_PERIODE+1
 
; Aufruf PROCEDURE (INIT_TIMER1_COMPA)
        CALL       INIT_TIMER1_COMPA
 
; SetBit(LED_ROT)
        SBI        PORTB, 0
 
; ENDCASE;
M_CASE_030:
 
; IF_THEN - Ende
M_IF_021:
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; ISR - Einsprung
TIMER1_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ARRAY - Ausdruck / Word-VAR (ZAEHLER_T1)
        LDS        R16, ZAEHLER_T1
        LDS        R17, ZAEHLER_T1+1
 
; Zuweisung Quelle - Ausdruck / ReadAdrArray (ARRAY_ADRESSE)
        LDS        ZL, ARRAY_ADRESSE
        LDS        ZH, ARRAY_ADRESSE+1
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (SIN_WERT)
        STS        SIN_WERT, R16
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SIN_WERT)
        LDS        R16, SIN_WERT
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; INC(ZAEHLER_T1) - Word
        LDS        R24, ZAEHLER_T1
        LDS        R25, ZAEHLER_T1+1
        ADIW       R25:R24, 1
        STS        ZAEHLER_T1, R24
        STS        ZAEHLER_T1+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (ZAEHLER_T1)
        LDS        R16, ZAEHLER_T1
        LDS        R17, ZAEHLER_T1+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_043
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_044
M_VERGL_043:
        SER        R16
M_VERGL_044:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_040
        RJMP       M_IF_041
M_IF_040:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER_T1)
        STS        ZAEHLER_T1, R16
        STS        ZAEHLER_T1+1, R17
 
; IF_THEN - Ende
M_IF_041:
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (CHANGE_MODE)
CHANGE_MODE:
 
; CASE OF - lokaler Uebergabeparameter (DATA_BYTE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (SE_SOUND)
        CPI        R16, 0x0F
        BREQ       M_CASE_047
        RJMP       M_CASE_046
M_CASE_047:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SEND_SOUND)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (SEND_MODE)
        STS        SEND_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_045
M_CASE_046:
 
; CASE OF - vergleiche Einzel-Element (RE_WHO_ARE_YOU)
        CPI        R16, 0x14
        BREQ       M_CASE_049
        RJMP       M_CASE_048
M_CASE_049:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RECEIVE_DEVCODE)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_045
M_CASE_048:
 
; CASE OF - vergleiche Einzel-Element (RE_ERROR_CODE)
        CPI        R16, 0x0A
        BREQ       M_CASE_051
        RJMP       M_CASE_050
M_CASE_051:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RECEIVE_ERROR_CODE)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_045
 
; CASE OF ELSE
M_CASE_050:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (ERROR_PARAM)
        STS        ERROR_PARAM, R16
 
; ENDCASE;
M_CASE_045:
 
; PROCEDURE - Ende (CHANGE_MODE)
        RET
 
; PROCEDURE - Anfang (DATA_SEND)
DATA_SEND:
 
; CASE OF - Byte-VAR (SEND_MODE)
        LDS        R16, SEND_MODE
 
; CASE OF - vergleiche Einzel-Element (NO_SEND_MODE)
        CPI        R16, 0x00
        BREQ       M_CASE_054
        RJMP       M_CASE_053
M_CASE_054:
 
; Retten der lokalen Parameter fuer PROCEDURE (DATA_SEND)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (CHANGE_MODE)
        CALL       CHANGE_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (DATA_SEND)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_052
M_CASE_053:
 
; CASE OF - vergleiche Einzel-Element (SEND_SOUND)
        CPI        R16, 0x01
        BREQ       M_CASE_056
        RJMP       M_CASE_055
M_CASE_056:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (SOUND_BYTE)
        STS        SOUND_BYTE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SEND_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SEND_MODE)
        STS        SEND_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RECEIVE_SOUND)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_052
 
; CASE OF ELSE
M_CASE_055:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (ERROR_PARAM)
        STS        ERROR_PARAM, R16
 
; ENDCASE;
M_CASE_052:
 
; PROCEDURE - Ende (DATA_SEND)
        RET
 
; PROCEDURE - Anfang (SEND_ONE_NIBBLE)
SEND_ONE_NIBBLE:
 
; ClearBit(CDEN_A)
        CBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (ONE_NIBBLE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; WHILE DO ...
M_WHILE_057:
 
; WHILE - Ausdruck /; BitLow(CRAC_E)
        IN         R16, PINB
        BST        R16, 2
        BRTC       M_VERGL_060
        CLR        R16
        RJMP       M_VERGL_061
M_VERGL_060:
        SER        R16
M_VERGL_061:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_058
        RJMP       M_WHILE_059
M_WHILE_058:
 
; SetBit(CDEN_A)
        SBI        PORTB, 1
 
; WHILE DO ...
        RJMP       M_WHILE_057
M_WHILE_059:
 
; WHILE DO ...
M_WHILE_062:
 
; WHILE - Ausdruck /; BitHigh(CRAC_E)
        IN         R16, PINB
        BST        R16, 2
        BRTS       M_VERGL_065
        CLR        R16
        RJMP       M_VERGL_066
M_VERGL_065:
        SER        R16
M_VERGL_066:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_063
        RJMP       M_WHILE_064
M_WHILE_063:
 
; ClearBit(CDEN_A)
        CBI        PORTB, 1
 
; WHILE DO ...
        RJMP       M_WHILE_062
M_WHILE_064:
 
; PROCEDURE - Ende (SEND_ONE_NIBBLE)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_MESSAGE)
RUN_RECEIVE_MESSAGE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (RECEIVE_MESSAGE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ONE_NIBBLE)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        PUSH       R0
        PUSH       R1
 
; Parameter (ONE_NIBBLE) retten
        MOV        R17, R1
 
; lokalen Parameter (ONE_NIBBLE) an Prozedur (SEND_ONE_NIBBLE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SEND_ONE_NIBBLE)
        CALL       SEND_ONE_NIBBLE
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (RECEIVE_MESSAGE)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ONE_NIBBLE)
        MOV        R1, R16
 
; SHR(ONE_NIBBLE) - Byte
        LSR        R1
 
; SHR(ONE_NIBBLE) - Byte
        LSR        R1
 
; SHR(ONE_NIBBLE) - Byte
        LSR        R1
 
; SHR(ONE_NIBBLE) - Byte
        LSR        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        PUSH       R0
        PUSH       R1
 
; Parameter (ONE_NIBBLE) retten
        MOV        R17, R1
 
; lokalen Parameter (ONE_NIBBLE) an Prozedur (SEND_ONE_NIBBLE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SEND_ONE_NIBBLE)
        CALL       SEND_ONE_NIBBLE
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (RUN_RECEIVE_MESSAGE)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_SOUND)
RUN_RECEIVE_SOUND:
 
; Aufruf PROCEDURE (LESE_SOUND_BYTE)
        CALL       LESE_SOUND_BYTE
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; PROCEDURE - Ende (RUN_RECEIVE_SOUND)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_DEVCODE)
RUN_RECEIVE_DEVCODE:
 
; Byte-Parameter(1) fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        LDI        R16, 0x07
        MOV        R0, R16
 
; Aufruf PROCEDURE (RUN_RECEIVE_MESSAGE)
        CALL       RUN_RECEIVE_MESSAGE
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; PROCEDURE - Ende (RUN_RECEIVE_DEVCODE)
        RET
 
; PROCEDURE - Anfang (RUN_RECEIVE_ERROR_CODE)
RUN_RECEIVE_ERROR_CODE:
 
; Byte-Parameter(1) fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        LDS        R0, ERROR_CODE
 
; Aufruf PROCEDURE (RUN_RECEIVE_MESSAGE)
        CALL       RUN_RECEIVE_MESSAGE
 
; Byte-Parameter(1) fuer PROCEDURE (RUN_RECEIVE_MESSAGE)
        LDS        R0, ERROR_PARAM
 
; Aufruf PROCEDURE (RUN_RECEIVE_MESSAGE)
        CALL       RUN_RECEIVE_MESSAGE
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; PROCEDURE - Ende (RUN_RECEIVE_ERROR_CODE)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_KEINEBA)
RUN_BA_MODE_KEINEBA:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (BA_MODE_INI)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (BA_MODE)
        STS        BA_MODE, R16
 
; PROCEDURE - Ende (RUN_BA_MODE_KEINEBA)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_SET_RD)
RUN_BA_MODE_SET_RD:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG DDRC
        IN         R16, DDRC
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ClearBit(CDEN_A)
        CBI        PORTB, 1
 
; SetBit(CDEN_P)
        SBI        DDRB, 1
 
; ClearBit(CDEN_A)
        CBI        PORTB, 1
 
; ClearBit(CRAC_P)
        CBI        DDRB, 2
 
; ClearBit(DDAC_A)
        CBI        PORTC, 5
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (BA_MODE_RD)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (BA_MODE)
        STS        BA_MODE, R16
 
; PROCEDURE - Ende (RUN_BA_MODE_SET_RD)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_INI)
RUN_BA_MODE_INI:
 
; IF THEN - Ausdruck /; BitLow(DDWR_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_070
        CLR        R16
        RJMP       M_VERGL_071
M_VERGL_070:
        SER        R16
M_VERGL_071:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_067
        RJMP       M_IF_068
M_IF_067:
 
; Aufruf PROCEDURE (RUN_BA_MODE_SET_RD)
        CALL       RUN_BA_MODE_SET_RD
 
; IF_THEN - Ende
M_IF_068:
 
; PROCEDURE - Ende (RUN_BA_MODE_INI)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_SET_WR)
RUN_BA_MODE_SET_WR:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (BA_MODE_WR)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (BA_MODE)
        STS        BA_MODE, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG DDRC
        IN         R16, DDRC
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ClearBit(CDEN_P)
        CBI        DDRB, 1
 
; ClearBit(CRAC_A)
        CBI        PORTB, 2
 
; SetBit(CRAC_P)
        SBI        DDRB, 2
 
; ClearBit(CRAC_A)
        CBI        PORTB, 2
 
; SetBit(DDAC_A)
        SBI        PORTC, 5
 
; PROCEDURE - Ende (RUN_BA_MODE_SET_WR)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_RD)
RUN_BA_MODE_RD:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (RECEIVE_MODE)
        LDS        R16, RECEIVE_MODE
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_075
        CLR        R16
        RJMP       M_VERGL_076
M_VERGL_075:
        SER        R16
M_VERGL_076:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_072
        RJMP       M_IF_073
M_IF_072:
 
; CASE OF - Byte-VAR (RECEIVE_MODE)
        LDS        R16, RECEIVE_MODE
 
; CASE OF - vergleiche Einzel-Element (RECEIVE_SOUND)
        CPI        R16, 0x01
        BREQ       M_CASE_079
        RJMP       M_CASE_078
M_CASE_079:
 
; Aufruf PROCEDURE (RUN_RECEIVE_SOUND)
        CALL       RUN_RECEIVE_SOUND
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_077
M_CASE_078:
 
; CASE OF - vergleiche Einzel-Element (RECEIVE_DEVCODE)
        CPI        R16, 0x02
        BREQ       M_CASE_081
        RJMP       M_CASE_080
M_CASE_081:
 
; Aufruf PROCEDURE (RUN_RECEIVE_DEVCODE)
        CALL       RUN_RECEIVE_DEVCODE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_077
M_CASE_080:
 
; CASE OF - vergleiche Einzel-Element (RECEIVE_ERROR_CODE)
        CPI        R16, 0x03
        BREQ       M_CASE_083
        RJMP       M_CASE_082
M_CASE_083:
 
; Aufruf PROCEDURE (RUN_RECEIVE_ERROR_CODE)
        CALL       RUN_RECEIVE_ERROR_CODE
 
; ENDCASE;
M_CASE_082:
M_CASE_077:
 
; IF_THEN - Ende
M_IF_073:
 
; IF THEN - Ausdruck /; BitHigh(DDWR_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_087
        CLR        R16
        RJMP       M_VERGL_088
M_VERGL_087:
        SER        R16
M_VERGL_088:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_084
        RJMP       M_IF_085
M_IF_084:
 
; Aufruf PROCEDURE (RUN_BA_MODE_SET_WR)
        CALL       RUN_BA_MODE_SET_WR
 
; IF_THEN - Ende
M_IF_085:
 
; PROCEDURE - Ende (RUN_BA_MODE_RD)
        RET
 
; PROCEDURE - Anfang (RUN_BA_MODE_WR)
RUN_BA_MODE_WR:
 
; IF THEN - Ausdruck /; BitHigh(CDEN_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_092
        CLR        R16
        RJMP       M_VERGL_093
M_VERGL_092:
        SER        R16
M_VERGL_093:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_089
        RJMP       M_IF_090
M_IF_089:
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BUF_LOW)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DATA_BUF_LOW)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BUF_LOW)
        MOV        R0, R16
 
; WHILE DO ...
M_WHILE_094:
 
; WHILE - Ausdruck /; BitHigh(CDEN_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_097
        CLR        R16
        RJMP       M_VERGL_098
M_VERGL_097:
        SER        R16
M_VERGL_098:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_095
        RJMP       M_WHILE_096
M_WHILE_095:
 
; SetBit(CRAC_A)
        SBI        PORTB, 2
 
; WHILE DO ...
        RJMP       M_WHILE_094
M_WHILE_096:
 
; WHILE DO ...
M_WHILE_099:
 
; WHILE - Ausdruck /; BitLow(CDEN_E)
        IN         R16, PINB
        BST        R16, 1
        BRTC       M_VERGL_0102
        CLR        R16
        RJMP       M_VERGL_0103
M_VERGL_0102:
        SER        R16
M_VERGL_0103:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0100
        RJMP       M_WHILE_0101
M_WHILE_0100:
 
; ClearBit(CRAC_A)
        CBI        PORTB, 2
 
; WHILE DO ...
        RJMP       M_WHILE_099
M_WHILE_0101:
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BUF_HIGH)
        MOV        R1, R16
 
; SHL(DATA_BUF_HIGH) - Byte
        LSL        R1
 
; SHL(DATA_BUF_HIGH) - Byte
        LSL        R1
 
; SHL(DATA_BUF_HIGH) - Byte
        LSL        R1
 
; SHL(DATA_BUF_HIGH) - Byte
        LSL        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DATA_BUF_HIGH)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (DATA_BUF_LOW)
        MOV        R18, R0
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BUF)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_BA_MODE_WR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (DATA_BUF) retten
        MOV        R18, R2
 
; lokalen Parameter (DATA_BUF) an Prozedur (DATA_SEND)
        MOV        R0, R18
 
; Aufruf PROCEDURE (DATA_SEND)
        CALL       DATA_SEND
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_BA_MODE_WR)
        POP        R2
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0104:
 
; WHILE - Ausdruck /; BitHigh(CDEN_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_0107
        CLR        R16
        RJMP       M_VERGL_0108
M_VERGL_0107:
        SER        R16
M_VERGL_0108:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0105
        RJMP       M_WHILE_0106
M_WHILE_0105:
 
; SetBit(CRAC_A)
        SBI        PORTB, 2
 
; WHILE DO ...
        RJMP       M_WHILE_0104
M_WHILE_0106:
 
; ClearBit(CRAC_A)
        CBI        PORTB, 2
 
; IF_THEN - Ende
M_IF_090:
 
; IF THEN - Ausdruck /; BitLow(DDWR_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0112
        CLR        R16
        RJMP       M_VERGL_0113
M_VERGL_0112:
        SER        R16
M_VERGL_0113:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0109
        RJMP       M_IF_0110
M_IF_0109:
 
; Retten der lokalen Parameter fuer PROCEDURE (RUN_BA_MODE_WR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (RUN_BA_MODE_SET_RD)
        CALL       RUN_BA_MODE_SET_RD
 
; Retten der Parameter-Register fuer PROCEDURE (RUN_BA_MODE_WR)
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0110:
 
; PROCEDURE - Ende (RUN_BA_MODE_WR)
        RET
 
; ISR - Einsprung
TIMER2_OVF:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; CASE OF - Byte-VAR (BA_MODE)
        LDS        R16, BA_MODE
 
; CASE OF - vergleiche Einzel-Element (BA_MODE_KEINEBA)
        CPI        R16, 0x00
        BREQ       M_CASE_0116
        RJMP       M_CASE_0115
M_CASE_0116:
 
; Aufruf PROCEDURE (RUN_BA_MODE_KEINEBA)
        CALL       RUN_BA_MODE_KEINEBA
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0114
M_CASE_0115:
 
; CASE OF - vergleiche Einzel-Element (BA_MODE_INI)
        CPI        R16, 0x01
        BREQ       M_CASE_0118
        RJMP       M_CASE_0117
M_CASE_0118:
 
; Aufruf PROCEDURE (RUN_BA_MODE_INI)
        CALL       RUN_BA_MODE_INI
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0114
M_CASE_0117:
 
; CASE OF - vergleiche Einzel-Element (BA_MODE_RD)
        CPI        R16, 0x05
        BREQ       M_CASE_0120
        RJMP       M_CASE_0119
M_CASE_0120:
 
; Aufruf PROCEDURE (RUN_BA_MODE_RD)
        CALL       RUN_BA_MODE_RD
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0114
M_CASE_0119:
 
; CASE OF - vergleiche Einzel-Element (BA_MODE_WR)
        CPI        R16, 0x03
        BREQ       M_CASE_0122
        RJMP       M_CASE_0121
M_CASE_0122:
 
; Aufruf PROCEDURE (RUN_BA_MODE_WR)
        CALL       RUN_BA_MODE_WR
 
; ENDCASE;
M_CASE_0121:
M_CASE_0114:
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER_T0)
        STS        ZAEHLER_T0, R16
        STS        ZAEHLER_T0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER_T1)
        STS        ZAEHLER_T1, R16
        STS        ZAEHLER_T1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (SND_KEIN_BEFEHL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SOUND_BEFEHL)
        STS        SOUND_BEFEHL, R16
 
; Aufruf PROCEDURE (INITADRESSEN)
        CALL       INITADRESSEN
 
; SetBit(DDAC_A)
        SBI        PORTC, 5
 
; ClearBit(CRAC_A)
        CBI        PORTB, 2
 
; ClearBit(LED_ROT)
        CBI        PORTB, 0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (BA_MODE_KEINEBA)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (BA_MODE)
        STS        BA_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SEND_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SEND_MODE)
        STS        SEND_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_RECEIVE_MODE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RECEIVE_MODE)
        STS        RECEIVE_MODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ERROR_CODE)
        STS        ERROR_CODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ERROR_PARAM)
        STS        ERROR_PARAM, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_TIMER2_OVF)
        CALL       INIT_TIMER2_OVF
 
; Interrupt erlauben
        SEI
 
; LOOP - Start_Marke
M_LOOP_0123:
 
; LOOP - Ende
        RJMP       M_LOOP_0123
 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; TIMER0_AUS (P) 
; INIT_TIMER0_OVF (P) 
; TIMER1_AUS (P) 
; INIT_TIMER1_COMPA (P) 
; INIT_TIMER2_OVF (P) 
; SND_KEIN_BEFEHL (C) BYTE Wert=0x00
; SND_RESET_LIED_TAB (C) BYTE Wert=0x01
; SND_LADE_LIED_TAB (C) BYTE Wert=0x02
; SND_SPIELE_LIED_TAB (C) BYTE Wert=0x03
; SND_SETZE_MIDI (C) BYTE Wert=0x04
; SND_SETZE_DAUER (C) BYTE Wert=0x05
; SND_SETZE_INSTR (C) BYTE Wert=0x06
; SND_SPIELE_SAVE_TAB (C) BYTE Wert=0x0C
; INSTR_KIRCHENORGEL (C) BYTE Wert=0x00
; INSTR_SINUS (C) BYTE Wert=0x01
; BA_MODE_KEINEBA (C) BYTE Wert=0x00
; BA_MODE_INI (C) BYTE Wert=0x01
; BA_MODE_SET_WR (C) BYTE Wert=0x02
; BA_MODE_WR (C) BYTE Wert=0x03
; BA_MODE_SET_RD (C) BYTE Wert=0x04
; BA_MODE_RD (C) BYTE Wert=0x05
; NO_RECEIVE_MODE (C) BYTE Wert=0x00
; RECEIVE_SOUND (C) BYTE Wert=0x01
; RECEIVE_DEVCODE (C) BYTE Wert=0x02
; RECEIVE_ERROR_CODE (C) BYTE Wert=0x03
; NO_SEND_MODE (C) BYTE Wert=0x00
; SEND_SOUND (C) BYTE Wert=0x01
; RE_CONST (C) BYTE Wert=0x01
; RE_CONIN (C) BYTE Wert=0x02
; SE_CONOUT (C) BYTE Wert=0x03
; RE_SECNT (C) BYTE Wert=0x04
; RE_SECTOR (C) BYTE Wert=0x05
; RE_RD_ISEC (C) BYTE Wert=0x06
; SE_WR_ISEC (C) BYTE Wert=0x07
; SE_STD (C) BYTE Wert=0x08
; SE_LIST (C) BYTE Wert=0x09
; RE_ERROR_CODE (C) BYTE Wert=0x0A
; SE_SOUND (C) BYTE Wert=0x0F
; RE_WHO_ARE_YOU (C) BYTE Wert=0x14
; DEVCODE_PC_CPM_EMU (C) BYTE Wert=0x02
; DEVCODE_KEYBOARD (C) BYTE Wert=0x03
; DEVCODE_DISPLAY (C) BYTE Wert=0x04
; DEVCODE_RAMFLOPPY (C) BYTE Wert=0x05
; DEVCODE_CONINOUT (C) BYTE Wert=0x06
; DEVCODE_SOUND (C) BYTE Wert=0x07
; MESSAGE_WHO_AM_I (C) BYTE Wert=0x07
; PIPE_ORGAN_TAB (A) 
; SINTAB (A) 
; MIDI_TAB (A) 
; LIED_TAB2_LAENGE (C) WORD Wert=0x001F
; LIED_TAB2 (A) 
; ZAEHLER_T0 (V) WORD
; ZAEHLER_T1 (V) WORD
; TON_PERIODE (V) WORD
; MIDI_NUMMER (V) WORD
; LIED_TAB_ZEIGER (V) WORD
; TON_DAUER (V) WORD
; LIED_TAB_LAENGE (V) WORD
; SIN_WERT (V) BYTE
; TON_DAUER_BYTE (V) BYTE
; MIDI_NUMMER_BYTE (V) BYTE
; LED_ROT (B) BIT
; BA_MODE (V) BYTE
; RECEIVE_MODE (V) BYTE
; SEND_MODE (V) BYTE
; ERROR_CODE (V) BYTE
; ERROR_PARAM (V) BYTE
; SOUND_BYTE (V) BYTE
; LADE_BYTE (V) BYTE
; DDWR_E (B) BIT
; DDAC_A (B) BIT
; CDEN_E (B) BIT
; CDEN_A (B) BIT
; CDEN_P (B) BIT
; CRAC_A (B) BIT
; CRAC_E (B) BIT
; CRAC_P (B) BIT
; LIED_TAB (Y) BYTE
; SOUND_BEFEHL (V) BYTE
; ARRAY_ADRESSE (V) ADRESS
; INITPORTS (P) 
; INITADRESSEN (P) 
; LESE_SOUND_BYTE (P) 
; CHANGE_MODE (P) 
; DATA_SEND (P) 
; SEND_ONE_NIBBLE (P) 
; RUN_RECEIVE_MESSAGE (P) 
; RUN_RECEIVE_SOUND (P) 
; RUN_RECEIVE_DEVCODE (P) 
; RUN_RECEIVE_ERROR_CODE (P) 
; RUN_BA_MODE_KEINEBA (P) 
; RUN_BA_MODE_SET_RD (P) 
; RUN_BA_MODE_INI (P) 
; RUN_BA_MODE_SET_WR (P) 
; RUN_BA_MODE_RD (P) 
; RUN_BA_MODE_WR (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE TIMER0_AUS;
; PROCEDURE INIT_TIMER0_OVF;
; PROCEDURE TIMER1_AUS;
; PROCEDURE INIT_TIMER1_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; PROCEDURE INIT_TIMER2_OVF;
; PROCEDURE INITPORTS;
; PROCEDURE INITADRESSEN;
; PROCEDURE LESE_SOUND_BYTE (W1 : WORD) (B1 : BYTE);
; PROCEDURE CHANGE_MODE (DATA_BYTE : BYTE);
; PROCEDURE DATA_SEND (DATA_BYTE : BYTE) (ZEICHEN : CHAR);
; PROCEDURE SEND_ONE_NIBBLE (ONE_NIBBLE : BYTE) (BIT_TEST : BYTE);
; PROCEDURE RUN_RECEIVE_MESSAGE (RECEIVE_MESSAGE : BYTE) (ONE_NIBBLE : BYTE);
; PROCEDURE RUN_RECEIVE_SOUND;
; PROCEDURE RUN_RECEIVE_DEVCODE;
; PROCEDURE RUN_RECEIVE_ERROR_CODE;
; PROCEDURE RUN_BA_MODE_KEINEBA;
; PROCEDURE RUN_BA_MODE_SET_RD;
; PROCEDURE RUN_BA_MODE_INI;
; PROCEDURE RUN_BA_MODE_SET_WR;
; PROCEDURE RUN_BA_MODE_RD;
; PROCEDURE RUN_BA_MODE_WR (DATA_BUF_LOW : BYTE) (DATA_BUF_HIGH : BYTE) (DATA_BUF : BYTE);
 
; *** Konstanten-ARRAYs ***
;
 
PIPE_ORGAN_TAB:
.db    0x81,0x6E
.db    0x5C,0x4B
.db    0x3A,0x2E
.db    0x2C,0x30
.db    0x36,0x3C
.db    0x41,0x43
.db    0x42,0x3E
.db    0x30,0x20
.db    0x11,0x07
.db    0x02,0x04
.db    0x0C,0x19
.db    0x2C,0x43
.db    0x58,0x68
.db    0x75,0x7E
.db    0x84,0x85
.db    0x80,0x78
.db    0x6F,0x67
.db    0x61,0x5C
.db    0x59,0x5B
.db    0x65,0x75
.db    0x87,0x96
.db    0xA4,0xAD
.db    0xB4,0xB4
.db    0xAA,0x9E
.db    0x94,0x8E
.db    0x8C,0x91
.db    0x9C,0xAB
.db    0xBF,0xD6
.db    0xE8,0xF4
.db    0xFC,0xFF
.db    0xFF,0xFB
.db    0xED,0xDC
.db    0xCB,0xBA
.db    0xAA,0x9C
.db    0x8F,0x88
.db    0x8C,0x92
.db    0x99,0xA0
.db    0xA4,0xA5
.db    0xA2,0x98
.db    0x88,0x75
.db    0x66,0x5B
.db    0x57,0x59
.db    0x5F,0x6D
.db    0x7F,0x93
.db    0xA2,0xAC
.db    0xB1,0xB4
.db    0xB2,0xAB
.db    0x9D,0x8D
.db    0x7F,0x71
.db    0x66,0x5B
.db    0x54,0x55
.db    0x5E,0x6A
.db    0x76,0x81
.db    0x8A,0x8F
.db    0x8F,0x8A
.db    0x7B,0x6E
.db    0x63,0x5D
.db    0x5C,0x60
.db    0x6A,0x79
.db    0x8D,0xA0
.db    0xAC,0xB5
.db    0xB8,0xB8
.db    0xB3,0xA8
.db    0x96,0x82
 
SINTAB:
.db    0x80,0x86
.db    0x8C,0x91
.db    0x97,0x9D
.db    0xA3,0xA9
.db    0xAE,0xB4
.db    0xB9,0xBE
.db    0xC4,0xC8
.db    0xCD,0xD2
.db    0xD6,0xDA
.db    0xDE,0xE2
.db    0xE5,0xE9
.db    0xEC,0xEE
.db    0xF1,0xF3
.db    0xF5,0xF6
.db    0xF8,0xF9
.db    0xF9,0xFA
.db    0xFA,0xFA
.db    0xF9,0xF9
.db    0xF8,0xF6
.db    0xF5,0xF3
.db    0xF1,0xEE
.db    0xEC,0xE9
.db    0xE5,0xE2
.db    0xDE,0xDA
.db    0xD6,0xD2
.db    0xCD,0xC8
.db    0xC4,0xBE
.db    0xB9,0xB4
.db    0xAE,0xA9
.db    0xA3,0x9D
.db    0x97,0x91
.db    0x8C,0x86
.db    0x80,0x79
.db    0x73,0x6E
.db    0x68,0x62
.db    0x5C,0x56
.db    0x51,0x4B
.db    0x46,0x41
.db    0x3B,0x37
.db    0x32,0x2D
.db    0x29,0x25
.db    0x21,0x1D
.db    0x1A,0x16
.db    0x13,0x11
.db    0x0E,0x0C
.db    0x0A,0x09
.db    0x07,0x06
.db    0x06,0x05
.db    0x05,0x05
.db    0x06,0x06
.db    0x07,0x09
.db    0x0A,0x0C
.db    0x0E,0x11
.db    0x13,0x16
.db    0x1A,0x1D
.db    0x21,0x25
.db    0x29,0x2D
.db    0x32,0x37
.db    0x3B,0x41
.db    0x46,0x4B
.db    0x51,0x56
.db    0x5C,0x62
.db    0x68,0x6E
.db    0x73,0x79
 
MIDI_TAB:
.dw    0x4C71
.dw    0x4827
.dw    0x441B
.dw    0x4048
.dw    0x3CAC
.dw    0x3945
.dw    0x360E
.dw    0x3305
.dw    0x3029
.dw    0x2D74
.dw    0x2AE7
.dw    0x287F
.dw    0x2639
.dw    0x2414
.dw    0x220D
.dw    0x2024
.dw    0x1E57
.dw    0x1CA3
.dw    0x1B07
.dw    0x1983
.dw    0x1814
.dw    0x16BA
.dw    0x1574
.dw    0x1440
.dw    0x131D
.dw    0x120A
.dw    0x1107
.dw    0x1012
.dw    0x0F2B
.dw    0x0E51
.dw    0x0D84
.dw    0x0CC1
.dw    0x0C0A
.dw    0x0B5D
.dw    0x0ABA
.dw    0x0A20
.dw    0x098E
.dw    0x0905
.dw    0x0883
.dw    0x0809
.dw    0x0796
.dw    0x0729
.dw    0x06C2
.dw    0x0661
.dw    0x0605
.dw    0x05AF
.dw    0x055D
.dw    0x0510
.dw    0x04C7
.dw    0x0482
.dw    0x0442
.dw    0x0405
.dw    0x03CB
.dw    0x0394
.dw    0x0361
.dw    0x0330
.dw    0x0303
.dw    0x02D7
.dw    0x02AE
.dw    0x0288
.dw    0x0264
.dw    0x0241
.dw    0x0221
.dw    0x0202
.dw    0x01E5
.dw    0x01CA
.dw    0x01B0
.dw    0x0198
.dw    0x0181
.dw    0x016C
.dw    0x0157
.dw    0x0144
.dw    0x0132
.dw    0x0121
.dw    0x0110
.dw    0x0101
.dw    0x00F3
.dw    0x00E5
.dw    0x00D8
.dw    0x00CC
.dw    0x00C1
.dw    0x00B6
.dw    0x00AC
.dw    0x00A2
.dw    0x0099
.dw    0x0090
.dw    0x0088
.dw    0x0081
.dw    0x0079
.dw    0x0073
.dw    0x006C
.dw    0x0066
.dw    0x0060
.dw    0x005B
.dw    0x0056
.dw    0x0051
.dw    0x004C
.dw    0x0048
.dw    0x0044
.dw    0x0040
.dw    0x003D
.dw    0x0039
.dw    0x0036
.dw    0x0033
.dw    0x0030
.dw    0x002D
.dw    0x002B
.dw    0x0028
.dw    0x0026
.dw    0x0024
.dw    0x0022
.dw    0x0020
.dw    0x001E
.dw    0x001D
.dw    0x001B
.dw    0x001A
.dw    0x0018
.dw    0x0017
.dw    0x0015
.dw    0x0014
.dw    0x0013
.dw    0x0012
.dw    0x0011
.dw    0x0010
.dw    0x000F
.dw    0x000E
.dw    0x000E
.dw    0x000D
 
LIED_TAB2:
.db    0x3C,0x19
.db    0x40,0x50
.db    0x44,0x14
.db    0x00,0x3C
.db    0x3E,0x1E
.db    0x00,0x32
.db    0x44,0x5A
.db    0x00,0x14
.db    0x32,0x1E
.db    0x00,0x0F
.db    0x55,0x50
.db    0x00,0x28
.db    0x44,0x28
.db    0x00,0x32
.db    0x37,0x3C
.db    0x00,0x14
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=INT0          Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=INT1          Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=5    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=6    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=7    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=8    ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=9    ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=10   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=11   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=12   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=13   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=14   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=15   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=16   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=17   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=18   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=19   ORG=URXCaddr     ISR=USART_RXC     Bemerkung=USART, Rx Complete
; Nummer=20   ORG=UDREaddr     ISR=USART_UDRE    Bemerkung=USART Data Register Empty
; Nummer=21   ORG=UTXCaddr     ISR=USART_TXC     Bemerkung=USART, Tx Complete
; Nummer=22   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=23   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=26   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
